Index: main/waeup.uniben/trunk/etc/debug.ini.in
===================================================================
--- main/waeup.uniben/trunk/etc/debug.ini.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/debug.ini.in	(revision 9222)
@@ -66,2 +66,3 @@
 # set the name of the zope.conf file
 zope_conf = %(here)s/zope.conf
+env_vars = ZC_ASYNC_UUID ${buildout:directory}/var/uuid1.txt
Index: main/waeup.uniben/trunk/etc/deploy.ini.in
===================================================================
--- main/waeup.uniben/trunk/etc/deploy.ini.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/deploy.ini.in	(revision 9222)
@@ -59,2 +59,3 @@
 # set the name of the zope.conf file
 zope_conf = %(here)s/zope.conf
+env_vars = ZC_ASYNC_UUID ${buildout:directory}/var/uuid1.txt
Index: main/waeup.uniben/trunk/etc/profile.ini.in
===================================================================
--- main/waeup.uniben/trunk/etc/profile.ini.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/profile.ini.in	(revision 9222)
@@ -70,2 +70,3 @@
 # set the name of the zope.conf file
 zope_conf = %(here)s/zope.conf
+env_vars = ZC_ASYNC_UUID ${buildout:directory}/var/uuid1.txt
Index: main/waeup.uniben/trunk/etc/site.zcml.in
===================================================================
--- main/waeup.uniben/trunk/etc/site.zcml.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/site.zcml.in	(revision 9222)
@@ -5,4 +5,23 @@
   <include package="waeup.uniben" />
   <include package="waeup.uniben" file="mail.zcml" />
+
+  <!-- install job container
+
+       install a job container for asynchronous jobs. Pick one of the
+       two possibilites: 'single' for installation in the one big ZODB
+       or 'multidb' for setup with a dedicated ZODB for job handling.
+  -->
+  <!-- include package="waeup.kofa" file="async_single.zcml" / -->
+  <include package="waeup.kofa" file="async_multidb.zcml" />
+
+  <!-- install dispatcher and other needed async components
+
+       install other needed components for asynchronous jobs. Pick one
+       of the two possibilities: 'basic_dispatcher' for single ZODB
+       setup, 'multidb_dispatcher' for setup with a dedicated ZODB for
+       job handling. Make sure the setting matches the setting picked
+       above. -->
+  <!-- include package="zc.async" file="basic_dispatcher_policy.zcml" / -->
+  <include package="zc.async" file="multidb_dispatcher_policy.zcml" />
 
   <!-- Where should the datacenter reside by default? -->
Index: main/waeup.uniben/trunk/etc/zeo1.ini.in
===================================================================
--- main/waeup.uniben/trunk/etc/zeo1.ini.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/zeo1.ini.in	(revision 9222)
@@ -61,2 +61,3 @@
 # set the name of the zope.conf file
 zope_conf = %(here)s/zope_zeo1.conf
+env_vars = ZC_ASYNC_UUID ${buildout:directory}/var/uuid1.txt
Index: main/waeup.uniben/trunk/etc/zeo2.ini.in
===================================================================
--- main/waeup.uniben/trunk/etc/zeo2.ini.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/zeo2.ini.in	(revision 9222)
@@ -61,2 +61,3 @@
 # set the name of the zope.conf file
 zope_conf = %(here)s/zope_zeo2.conf
+env_vars = ZC_ASYNC_UUID ${buildout:directory}/var/uuid1.txt
Index: main/waeup.uniben/trunk/etc/zope.conf.in
===================================================================
--- main/waeup.uniben/trunk/etc/zope.conf.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/zope.conf.in	(revision 9222)
@@ -28,4 +28,11 @@
 </zodb>
 
+<zodb async>
+  <filestorage>
+    # create true
+    path ${zope_conf:filestorage}/Data.async.fs
+  </filestorage>
+</zodb>
+
 <eventlog>
   # This sets up logging to a file.
Index: main/waeup.uniben/trunk/etc/zope_zeo1.conf.in
===================================================================
--- main/waeup.uniben/trunk/etc/zope_zeo1.conf.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/zope_zeo1.conf.in	(revision 9222)
@@ -61,4 +61,16 @@
 </zodb>
 
+<zodb async>
+  <zeoclient>
+    server localhost:7010
+    storage async
+    name async
+    # ZEO client cache, in bytes
+    cache-size 20MB
+    # Uncomment to have a persistent disk cache
+    client ${zope_conf_zeo_1:filestorage}/zeo1_async
+  </zeoclient>
+</zodb>
+
 <eventlog>
   # This sets up logging to a file.
Index: main/waeup.uniben/trunk/etc/zope_zeo2.conf.in
===================================================================
--- main/waeup.uniben/trunk/etc/zope_zeo2.conf.in	(revision 9210)
+++ main/waeup.uniben/trunk/etc/zope_zeo2.conf.in	(revision 9222)
@@ -61,4 +61,16 @@
 </zodb>
 
+<zodb async>
+  <zeoclient>
+    server localhost:7010
+    storage async
+    name async
+    # ZEO client cache, in bytes
+    cache-size 20MB
+    # Uncomment to have a persistent disk cache
+    client ${zope_conf_zeo_2:filestorage}/zeo2_async
+  </zeoclient>
+</zodb>
+
 <eventlog>
   # This sets up logging to a file.
Index: main/waeup.uniben/trunk/setup.py
===================================================================
--- main/waeup.uniben/trunk/setup.py	(revision 9210)
+++ main/waeup.uniben/trunk/setup.py	(revision 9222)
@@ -95,6 +95,6 @@
       kofactl = grokcore.startup:zdaemon_controller
       [paste.app_factory]
-      main = grokcore.startup:application_factory
-      debug = grokcore.startup:debug_application_factory
+      main = waeup.kofa.startup:env_app_factory
+      debug = waeup.kofa.startup:env_debug_app_factory
       """,
       )
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 9210)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 9222)
@@ -21,5 +21,5 @@
 from waeup.kofa.interfaces import REQUESTED
 from waeup.kofa.widgets.datewidget import FriendlyDatetimeDisplayWidget
-from waeup.kofa.browser import KofaEditFormPage
+from waeup.kofa.browser.layout import KofaEditFormPage
 from waeup.kofa.browser.viewlets import ManageActionButton
 from waeup.kofa.browser.layout import action