Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py	(revision 9235)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py	(revision 9236)
@@ -24,4 +24,33 @@
 from kofacustom.nigeria.interfaces import MessageFactory as _
 
+# Acceptance Letter
+
+class AcceptanceLetterDisplay(FileDisplay):
+    """Acceptance Letter display viewlet.
+    """
+    grok.order(2)
+    label = _(u'Acceptance Letter')
+    title = _(u'Acceptance Letter Scan')
+    download_name = u'acc_let'
+
+class AcceptanceLetterSlip(AcceptanceLetterDisplay):
+    grok.view(ExportPDFClearanceSlipPage)
+
+class AcceptanceLetterUpload(FileUpload):
+    """AcceptanceLetter upload viewlet.
+    """
+    grok.order(2)
+    label = _(u'Acceptance Letter')
+    title = _(u'Acceptance Letter Scan')
+    mus = 1024 * 150
+    download_name = u'acc_let'
+    tab_redirect = '?tab2'
+
+class AcceptanceLetterImage(Image):
+    """Renders acceptance letter scan.
+    """
+    grok.name('acc_let')
+    download_name = u'acc_let'
+
 # LGA Identification
 
@@ -29,5 +58,5 @@
     """LGA Identification display viewlet.
     """
-    grok.order(1)
+    grok.order(3)
     label = _(u'LGA Identification')
     title = _(u'LGA Identification Scan')
@@ -40,5 +69,5 @@
     """LGA Identification upload viewlet.
     """
-    grok.order(2)
+    grok.order(3)
     label = _(u'LGA Identification')
     title = _(u'LGA Identification Scan')
@@ -57,5 +86,5 @@
     """First Sitting Result display viewlet.
     """
-    grok.order(1)
+    grok.order(4)
     label = _(u'First Sitting Result')
     title = _(u'First Sitting Result')
@@ -68,5 +97,5 @@
     """First Sitting Result upload viewlet.
     """
-    grok.order(2)
+    grok.order(4)
     label = _(u'First Sitting Result')
     title = _(u'First Sitting Result Scan')
@@ -85,5 +114,5 @@
     """Second Sitting Result display viewlet.
     """
-    grok.order(1)
+    grok.order(5)
     label = _(u'Second Sitting Result')
     title = _(u'Second Sitting Result')
@@ -96,5 +125,5 @@
     """Second Sitting Result upload viewlet.
     """
-    grok.order(2)
+    grok.order(5)
     label = _(u'Second Sitting Result')
     title = _(u'Second Sitting Result Scan')
@@ -113,5 +142,5 @@
     """Higher Qualification Result display viewlet.
     """
-    grok.order(1)
+    grok.order(6)
     label = _(u'Higher Qualification Result')
     title = _(u'Higher Qualification Result')
@@ -124,5 +153,5 @@
     """Higher Qualification Result upload viewlet.
     """
-    grok.order(2)
+    grok.order(6)
     label = _(u'Higher Qualification Result')
     title = _(u'Higher Qualification Result Scan')
@@ -141,5 +170,5 @@
     """Second Higher Qualification Result display viewlet.
     """
-    grok.order(1)
+    grok.order(7)
     label = _(u'Second Higher Qualification Result')
     title = _(u'Second Higher Qualification Result')
@@ -152,5 +181,5 @@
     """Second Higher Qualification Result upload viewlet.
     """
-    grok.order(2)
+    grok.order(7)
     label = _(u'Second Higher Qualification Result')
     title = _(u'Second Higher Qualification Result Scan')
@@ -176,5 +205,5 @@
     """Advanced Level Result display viewlet.
     """
-    grok.order(1)
+    grok.order(8)
     label = _(u'Advanced Level Result')
     title = _(u'Advanced Level Result')
@@ -187,5 +216,5 @@
     """Advanced Level Result upload viewlet.
     """
-    grok.order(2)
+    grok.order(8)
     label = _(u'Advanced Level Result')
     title = _(u'Advanced Level Result Scan')
@@ -204,8 +233,8 @@
     """Certificate display viewlet.
     """
-    grok.order(1)
+    grok.order(9)
     label = _(u'Certificate')
     title = _(u'Certificate')
-    download_name = u'certificate'
+    download_name = u'cert'
 
 class CertificateSlip(CertificateDisplay):
@@ -215,15 +244,15 @@
     """Certificate upload viewlet.
     """
-    grok.order(2)
+    grok.order(9)
     label = _(u'Certificate')
     title = _(u'Certificate Scan')
     mus = 1024 * 150
-    download_name = u'certificate'
+    download_name = u'cert'
 
 class CertificateImage(Image):
     """Renders Certificate scan.
     """
-    grok.name('certificate')
-    download_name = u'certificate'
+    grok.name('cert')
+    download_name = u'cert'
 
 # Second Certificate (PG Students only)
@@ -232,8 +261,8 @@
     """ Second Certificate display viewlet.
     """
-    grok.order(1)
+    grok.order(10)
     label = _(u'Second Certificate')
     title = _(u'Second Certificate')
-    download_name = u'certificate2'
+    download_name = u'cert2'
 
 class SecondCertificateSlip(SecondCertificateDisplay):
@@ -243,9 +272,9 @@
     """Second Certificate upload viewlet.
     """
-    grok.order(2)
+    grok.order(10)
     label = _(u'Second Certificate')
     title = _(u'Second Certificate Scan')
     mus = 1024 * 150
-    download_name = u'certificate2'
+    download_name = u'cert2'
 
     @property
@@ -259,6 +288,6 @@
     """Renders Second Certificate scan.
     """
-    grok.name('certificate2')
-    download_name = u'certificate2'
+    grok.name('cert2')
+    download_name = u'cert2'
 
 # Third Certificate (PG Students only)
@@ -267,8 +296,8 @@
     """ Third Certificate display viewlet.
     """
-    grok.order(1)
+    grok.order(11)
     label = _(u'Third Certificate')
     title = _(u'Third Certificate')
-    download_name = u'certificate3'
+    download_name = u'cert3'
 
 class ThirdCertificateSlip(ThirdCertificateDisplay):
@@ -278,9 +307,9 @@
     """Third Certificate upload viewlet.
     """
-    grok.order(2)
+    grok.order(11)
     label = _(u'Third Certificate')
     title = _(u'Third Certificate Scan')
     mus = 1024 * 150
-    download_name = u'certificate3'
+    download_name = u'cert3'
 
     @property
@@ -294,6 +323,6 @@
     """Renders Third Certificate scan.
     """
-    grok.name('certificate3')
-    download_name = u'certificate3'
+    grok.name('cert3')
+    download_name = u'cert3'
 
 # Evidence of Name
@@ -302,5 +331,5 @@
     """Evidence of Name display viewlet.
     """
-    grok.order(1)
+    grok.order(12)
     label = _(u'Evidence of Name')
     title = _(u'Evidence of Name')
@@ -313,5 +342,5 @@
     """Evidence of Name upload viewlet.
     """
-    grok.order(2)
+    grok.order(12)
     label = _(u'Evidence of Name')
     title = _(u'Evidence of Name Scan')
@@ -330,5 +359,5 @@
     """Result Statement display viewlet.
     """
-    grok.order(1)
+    grok.order(13)
     label = _(u'Result Statement')
     title = _(u'Result Statement')
@@ -341,5 +370,5 @@
     """Result Statement upload viewlet.
     """
-    grok.order(2)
+    grok.order(13)
     label = _(u'Result Statement')
     title = _(u'Result Statement Scan')
@@ -358,5 +387,5 @@
     """Referee Letter display viewlet.
     """
-    grok.order(1)
+    grok.order(14)
     label = _(u'Referee Letter')
     title = _(u'Referee Letter')
@@ -369,5 +398,5 @@
     """Referee Letter upload viewlet.
     """
-    grok.order(2)
+    grok.order(14)
     label = _(u'Referee Letter')
     title = _(u'Referee Letter Scan')
@@ -386,5 +415,5 @@
     """Second Referee Letter display viewlet.
     """
-    grok.order(1)
+    grok.order(15)
     label = _(u'Second Referee Letter')
     title = _(u'Second Referee Letter')
@@ -397,5 +426,5 @@
     """Referee Letter upload viewlet.
     """
-    grok.order(2)
+    grok.order(15)
     label = _(u'Second Referee Letter')
     title = _(u'Second Referee Letter Scan')
@@ -421,5 +450,5 @@
     """Third Referee Letter display viewlet.
     """
-    grok.order(1)
+    grok.order(16)
     label = _(u'Third Referee Letter')
     title = _(u'Third Referee Letter')
@@ -432,5 +461,5 @@
     """Referee Letter upload viewlet.
     """
-    grok.order(2)
+    grok.order(16)
     label = _(u'Third Referee Letter')
     title = _(u'Third Referee Letter Scan')
@@ -456,5 +485,5 @@
     """Statutory Declaration of Good Conduct display viewlet.
     """
-    grok.order(1)
+    grok.order(17)
     label = _(u'Statutory Declaration of Good Conduct')
     title = _(u'Statutory Declaration of Good Conduct')
@@ -467,5 +496,5 @@
     """Statutory Declaration of Good Conduct upload viewlet.
     """
-    grok.order(2)
+    grok.order(17)
     label = _(u'Statutory Declaration of Good Conduct')
     title = _(u'Statutory Declaration of Good Conduct Scan')
@@ -484,5 +513,5 @@
     """Letter of Admission display viewlet.
     """
-    grok.order(1)
+    grok.order(18)
     label = _(u'Letter of Admission')
     title = _(u'Letter of Admission')
@@ -495,5 +524,5 @@
     """Letter of Admission upload viewlet.
     """
-    grok.order(2)
+    grok.order(18)
     label = _(u'Letter of Admission')
     title = _(u'Letter of Admission Scan')